package betterwithmods.module.industry.multiblocks;

import betterwithmods.api.tile.multiblock.IMultiblock;
import betterwithmods.api.tile.multiblock.TileEntityMultiblock;
import betterwithmods.api.tile.multiblock.TileEntityProxyBlock;
import betterwithmods.common.BWMBlocks;
import betterwithmods.common.blocks.BlockSteel;
import betterwithmods.util.WorldUtils;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

public class Lathe implements IMultiblock {
    @Override
    public String getName() {
        return "Lathe";
    }

    @Override
    public IBlockState[][][] getStructure() {
        return new IBlockState[][][]{
                new IBlockState[][]{new IBlockState[]{Blocks.field_150350_a.func_176223_P(), Blocks.field_150350_a.func_176223_P(), BlockSteel.getBlock(0)}},
                new IBlockState[][]{new IBlockState[]{BlockSteel.getBlock(0), BlockSteel.getBlock(8), BWMBlocks.STEEL_GEARBOX.func_176223_P()}},
        };
    }

    @Override
    public BlockPos getOriginOffet(EnumFacing facing) {
        if (facing.func_176740_k().func_176720_b())
            return null;
        switch (facing) {
            case NORTH:
                return new BlockPos(-1, 0, 0);
            case SOUTH:
                return new BlockPos(1, 0, 0);
            case WEST:
                return new BlockPos(0, 0, -1);
            case EAST:
                return new BlockPos(0, 0, 1);
            default:
                return null;
        }
    }

    @Override
    public void createMultiBlock(World world, BlockPos pos, EnumFacing facing) {
        BlockPos controller = pos;
        BlockPos offset = getOriginOffet(facing);
        if (offset == null)
            return;
        BlockPos origin = pos.func_177971_a(offset);
        IBlockState[][][] structure = getStructure();
        for (int i = 0; i < structure.length; i++) {
            int y = structure.length - i - 1;
            for (int z = 0; z < structure[i].length; z++)
                for (int x = 0; x < structure[i][z].length; x++) {
                    BlockPos placement = facing.func_176740_k() == EnumFacing.Axis.X ? origin.func_177982_a(z, y, x) : origin.func_177982_a(x, y, z);
                    IBlockState state = world.func_180495_p(placement);
                    if (WorldUtils.matches(state, structure[i][z][x])) {
                        if (state.equals(Blocks.field_150350_a.func_176223_P()))
                            continue;
                        if (placement.equals(controller)) {
                            world.func_175656_a(controller, BWMBlocks.LATHE.func_176223_P());
                            TileEntity tile = world.func_175625_s(controller);
                            if (tile instanceof TileEntityMultiblock) {
                                ((TileEntityMultiblock) tile).setMultiblock(this);
                                ((TileEntityMultiblock) tile).setFacing(facing);
                            }
                        } else {
                            world.func_175656_a(placement, BWMBlocks.DUMMY.func_176223_P());
                            TileEntity tile = world.func_175625_s(placement);
                            if (tile instanceof TileEntityProxyBlock) {
                                ((TileEntityProxyBlock) tile).setController(controller);
                            }

                        }
                    }
                }
        }
    }

    @Override
    public void destroyMultiblock(World world, BlockPos pos, EnumFacing facing) {
        BlockPos offset = getOriginOffet(facing);
        if (offset == null)
            return;
        BlockPos origin = pos.func_177971_a(offset);
        IBlockState[][][] structure = getStructure();
        for (int i = 0; i < structure.length; i++) {
            int y = structure.length - i - 1;
            for (int z = 0; z < structure[i].length; z++)
                for (int x = 0; x < structure[i][z].length; x++) {
                    BlockPos placement = facing.func_176740_k() == EnumFacing.Axis.X ? origin.func_177982_a(z, y, x) : origin.func_177982_a(x, y, z);
                    if (!world.func_175623_d(placement))
                        world.func_175656_a(placement, structure[i][z][x]);
                }
        }
    }

}
